/*
 * Energy_meter.h
 *
 *  Created on: 19-Aug-2022
 *      Author: IITMRP
 */

#ifndef INC_ENERGY_METER_H_
#define INC_ENERGY_METER_H_

#include "main.h"
#include "stm32l4xx_it.h"
//#include <arm_math.h>
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <time.h>


#define FRAM_ADDRESS         0xA0 //0b10100000
#define ENERGY_ADDRESS     		0
#define ENERGY_MEM_SIZE         4
#define NUM_OF_SAMPLES  	  256
#define PI  3.14
#define DATA_RECEIVED   1
#define V_I_COMPUTED    2



extern ADC_HandleTypeDef hadc1;
extern I2C_HandleTypeDef hi2c1;
extern RTC_HandleTypeDef hrtc;
extern TIM_HandleTypeDef htim1;
extern UART_HandleTypeDef huart3;



void ADC_init();
float Read_voltage();
float Read_current();
float Measure_power_factor(float V_reading, float I_reading);
void Calc_RMS_values(float V_reading, float I_reading);
void Moving_Average_Filter(float * inputSignal, float * outputSignal, uint16_t arrSize, uint16_t nPoint);
void Read_FRAM(float data);
void Write_FRAM(float data);


//void ADC_init();
//void Read_voltage();
//void Read_current();
//void Measure_power_factor();
//void Calc_RMS_values();
//void calc_power_energy();
//void Moving_Average_Filter(float * inputSignal, float * outputSignal, uint16_t arrSize, uint16_t nPoint);
//void Read_FRAM(float data);
//void Write_FRAM(float data);
//void Transmit();


#endif /* INC_ENERGY_METER_H_ */
