/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.h
  * @brief          : Header for main.c file.
  *                   This file contains the common defines of the application.
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2022 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __MAIN_H
#define __MAIN_H

#ifdef __cplusplus
extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "stm32l4xx_hal.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#define NUM_OF_SAMPLES  256
/* USER CODE END Includes */

/* Exported types ------------------------------------------------------------*/
/* USER CODE BEGIN ET */
typedef struct
{
  float v_inst[NUM_OF_SAMPLES];
  float i_inst[NUM_OF_SAMPLES];

  float v_inst_filt[NUM_OF_SAMPLES];
  float i_inst_filt[NUM_OF_SAMPLES];

  float vrms;
  float irms;
  float power;
  float power_factor;
  float Energy;

  uint8_t status;
}Energy_Meter;

/* USER CODE END ET */

/* Exported constants --------------------------------------------------------*/
/* USER CODE BEGIN EC */

/* USER CODE END EC */

/* Exported macro ------------------------------------------------------------*/
/* USER CODE BEGIN EM */
#define FRAM_ADDRESS         0xA0 //0b10100000
#define ENERGY_ADDRESS     		0
#define ENERGY_MEM_SIZE         4
/* USER CODE END EM */

/* Exported functions prototypes ---------------------------------------------*/
void Error_Handler(void);

/* USER CODE BEGIN EFP */

/* USER CODE END EFP */

/* Private defines -----------------------------------------------------------*/
#define Volt_Pin GPIO_PIN_0
#define Volt_GPIO_Port GPIOA
#define Curr_Pin GPIO_PIN_1
#define Curr_GPIO_Port GPIOA
/* USER CODE BEGIN Private defines */


#define DATA_RECEIVED   1
#define V_I_COMPUTED    2


#define ARM_MATH_CM4

/* USER CODE END Private defines */

#ifdef __cplusplus
}
#endif

#endif /* __MAIN_H */
