/****************************************
 * Include Libraries
 ****************************************/
#include "UbidotsEsp32Mqtt.h"

/****************************************
 * Define Constants
 *********  *******************************/

const char *WIFI_SSID = "";      // Put your Wi-Fi SSID here
const char *WIFI_PASS = "";      // Put your Wi-Fi password here
const char *UBIDOTS_TOKEN = "";  // Put your Ubidots TOKEN here

const char *DEVICE_LABEL = "ENERGY_METER";   // Put here your Device label to which data  will be published

const char *VRMS_DEVICE_LABEL = "ENERGY_METER";   // Put here your Device label to which data  will be published
const char *VRMS_VARIABLE_LABEL = "VRMS"; // Put here your Variable label to which data  will be published

const char *IRMS_DEVICE_LABEL = "ENERGY_METER";   // Put here your Device label to which data  will be published
const char *IRMS_VARIABLE_LABEL = "IRMS"; // Put here your Variable label to which data  will be published

const char *POWER_DEVICE_LABEL = "ENERGY_METER";   // Put here your Device label to which data  will be published
const char *POWER_VARIABLE_LABEL = "POWER"; // Put here your Variable label to which data  will be published

const char *POWER_FACTOR_DEVICE_LABEL = "ENERGY_METER";   // Put here your Device label to which data  will be published
const char *POWER_FACTOR_VARIABLE_LABEL = "POWER_FACTOR"; // Put here your Variable label to which data  will be published

const char *ENERGY_DEVICE_LABEL = "ENERGY_METER";   // Put here your Device label to which data  will be published
const char *ENERGY_VARIABLE_LABEL = "ENERGY"; // Put here your Variable label to which data  will be published


const int PUBLISH_FREQUENCY = 2000; // Update rate in milliseconds

unsigned long timer;
uint8_t analogPin = 34; // Pin used to read data from GPIO34 ADC_CH6.

Ubidots ubidots(UBIDOTS_TOKEN);

/****************************************
 * Auxiliar Functions
 ****************************************/

void callback(char *topic, byte *payload, unsigned int length)
{
  Serial.print("Message arrived [");
  Serial.print(topic);
  Serial.print("] ");
  for (int i = 0; i < length; i++)
  {
    Serial.print((char)payload[i]);
  }
  Serial.println();
}

/****************************************
 * Main Functions
 ****************************************/

void setup()
{
  // put your setup code here, to run once:
  Serial.begin(9600);
  // ubidots.setDebug(true);  // uncomment this to make debug messages available
  ubidots.connectToWifi(WIFI_SSID, WIFI_PASS);
  ubidots.setCallback(callback);
  ubidots.setup();
  ubidots.reconnect();

  timer = millis();
}
String rxed="";
String rtc_string="";
String vrms_string="";
String irms_string="";
String power_string="";
String powerfactor_string="";
String energy_string="";

  float vol[400]={0.0};
   float cur[400]={0.0};
    float power=0.0;
     float powerfactor=0.0;
     float irms=0.0;
     float vrms=0.0;
     long int rtc =0;
     float energy=0.0;





void loop()
{


 
  if (!ubidots.connected())
  {
    ubidots.reconnect();
  }
 // myString.toFloat()
 
  if(Serial.available()>0)
  {

//    Serial.write(Serial.read());


rxed = Serial.readStringUntil('\n'); // 1645731957 024.36 000.11 -00.58 000.30 225093 // 1645732138 240.97 000.18 044.63 001.00 002.39
//rtc_string = rxed.substring(0,10); // 4*3 = 12 , 5*85= 425, 
vrms_string = rxed.substring(0,6);
irms_string= rxed.substring(6,12); // +2
powerfactor_string= rxed.substring(12,18);// +2 
power_string = rxed.substring(18,24);// +2 
energy_string = rxed.substring(24,30);// 



delay(10);



vrms = vrms_string.toFloat();
irms = irms_string.toFloat();
power = power_string.toFloat();
powerfactor = powerfactor_string.toFloat();
energy = energy_string.toFloat();



Serial.print("Vrms: ");
Serial.print(vrms);
Serial.print(", ");

Serial.print("Irms: ");
Serial.print(irms);
Serial.print(", ");

Serial.print("Power factor: ");
Serial.print(powerfactor);
Serial.print(", ");

Serial.print("Power: ");
Serial.print(power);
Serial.print(", ");

Serial.print("Energy: ");
Serial.println(energy);


  if ((millis() - timer) > (unsigned long)PUBLISH_FREQUENCY) // triggers the routine every 5 seconds
  {

    ubidots.add(VRMS_VARIABLE_LABEL, vrms); // Insert your variable Labels and the value to be sent
    ubidots.publish(DEVICE_LABEL);
    delay(500);
    ubidots.add(IRMS_VARIABLE_LABEL, irms); // Insert your variable Labels and the value to be sent
    ubidots.publish(DEVICE_LABEL);
    timer = millis();
    delay(500);
    ubidots.add(POWER_VARIABLE_LABEL, power); // Insert your variable Labels and the value to be sent
    ubidots.publish(DEVICE_LABEL);
    timer = millis();
    delay(500);
    ubidots.add(POWER_FACTOR_VARIABLE_LABEL, powerfactor); // Insert your variable Labels and the value to be sent
    ubidots.publish(DEVICE_LABEL);
    timer = millis();
    delay(500);
     ubidots.add(ENERGY_VARIABLE_LABEL, energy); // Insert your variable Labels and the value to be sent
    ubidots.publish(DEVICE_LABEL);
    timer = millis();
    delay(500);
    ubidots.loop();
  }
  
Serial.flush();
delay(10);


  }

  
}
